/*
 * CAU-sniffer.c
 *
 * Demonstration for Metasploit presentation
 * Compile for impurity using included Makefile
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/ip.h>
#include <linux/tcp.h>

#include <features.h>    /* for the glibc version number */

#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#endif


#define PSIZE	512
#define SIZE	20
#define ETH	"eth0"

int sock;
int promisc = 1;
struct ifreq interface;

int init(char *eth)
{
	if (getuid() > 0)
	{
		printf("Must be superuser to open sockets\n");
		exit(1);
	}

	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(0x800))) < 0)
	{
		perror("socket");
		exit(1);
	}

	strcpy(interface.ifr_name, eth);
	if (ioctl(sock, SIOCGIFFLAGS, &interface) < 0)
	{
		perror("ioctl");
		close(sock);
		exit(1);
	}

	if (promisc)
		interface.ifr_flags |= IFF_PROMISC;

	if (ioctl(sock, SIOCSIFFLAGS, &interface) < 0)
	{
		perror("ioctl");
		close(sock);
		exit(1);
	}
}

void destroy()
{
	printf("Exiting sniffer...\n");

	if (promisc)
		interface.ifr_flags ^= IFF_PROMISC;

	if (ioctl(sock, SIOCSIFFLAGS, &interface) < 0)
	{
		perror("ioctl");
		close(sock);
		exit(1);
	}

	exit(0);
}

int main(int argc, char *argv[])
{
	int option, verbose, osvdbid, i;
//	unsigned char *eth, *src, *packet;
	unsigned char src[10], packet[512], eth[] = "eth1";
	extern char *optarg;

	seteuid(0);
	setegid(0);

	signal (SIGINT, destroy);
	signal (SIGQUIT, destroy);
	signal (SIGTERM, destroy);
	signal (SIGKILL, destroy);

	//eth = malloc(SIZE);
	//packet = malloc(PSIZE);

	strcpy(eth, ETH);

	init(eth);

	while (1)
	{
		memset(packet, 0, 512);

		if (recv(sock, packet-5, 512, 0))
		{


			for(i=0; i<256; i++)
			{
				if (i%16 == 0)
				{
					printf("\n");
				}
				printf("%02x ", packet[i]);
			}
			printf("\n");
			for(i=0; i<256; i++)
			{
				if (i%16 == 0)
				{
					printf("\n");
				}
				if ( isalnum(packet[i]) )
					printf("%c", packet[i]);
			}
			printf("\n");


		}
	}

	destroy();
}
